import 'package:flutter/gestures.dart';
import 'package:flutter/material.dart';

class CustomLongTap extends StatelessWidget {
  const CustomLongTap(
      {Key key,
      this.duration = const Duration(milliseconds: 500),
      this.onLongTap,
      this.onShortTap,
      this.widget})
      : super(key: key);
  final Duration duration;
  final Function onLongTap;
  final Function onShortTap;
  final Widget widget;
  @override
  Widget build(BuildContext context) {
    return Scaffold(
      body: RawGestureDetector(
        child: widget,
        gestures: {
          TapGestureRecognizer:
              GestureRecognizerFactoryWithHandlers<TapGestureRecognizer>(
                  () => TapGestureRecognizer(),
                  (TapGestureRecognizer instance) {
            instance..onTap = onShortTap;
          }),
          LongPressGestureRecognizer:
              GestureRecognizerFactoryWithHandlers<LongPressGestureRecognizer>(
            () => LongPressGestureRecognizer(duration: duration),
            (LongPressGestureRecognizer instance) {
              instance..onLongPress = onLongTap;
            },
          ),
        },
      ),
    );
  }
}
